      SUBROUTINE QSF7D(RINT1,RINT2,A,B,F,RO,FI,E,ALFA,BETA,
     1XA,E1,L1,L2)
      DIMENSION G(5),L(5),M(5),Q1(5),BE(7)
      INTEGER L1,L2,N,IL,D
      DOUBLE PRECISION RINT1,RINT2,A,B,F,RO,FI,E,ALFA,BETA,
     1XA,E1,G,L,M,Q1,BE,RINT3,RINT4,I,J,K,EPS,TAU,W,Z2,H,Z1,
     1P,R,Q,V,T,S,Z,BA,BD,X,Y,H0,BB,BC,HM,C,U,BF,SYS059
      LOGICAL NI
      DATA  SYS059/1.7D308/,HM/2.D-10/
      EPS=E
      XA=-SYS059
      IL=1
      NI=A.GT.B
      IF(.NOT.(NI)) GO TO 1
      C=A
      A=B
      B=C
    1 W=B-A
      IF(.NOT.(W.EQ.0.D0)) GO TO 2
      RINT1=0.D0
      RINT2=0.D0
      E1=0.D0
      GO TO 42
    2 IF(BETA-ALFA) 3,4,5
    3 C=ALFA
      ALFA=BETA
      BETA=C
      GO TO 5
    4 ALFA=ALFA-HM
      BETA=BETA+HM
    5 ALFA=(ALFA-A)/W
      BETA=(BETA-A)/W
      TAU=(BETA-ALFA)/2.D0
      IF(TAU-HM) 6,6,7
    6 TAU=HM
    7 Z2=E/W
      H=1.D0
      N=0
      Z1=EPS/W
    8 P=0.D0
      E1=0.D0
      RINT1=0.D0
      RINT2=0.D0
    9 IF(.NOT.(P.LT.BETA.AND.(P+H).GT.ALFA.AND.H.GT.TAU))
     1 GO TO 10
      H=TAU
      IF(P.GE.ALFA) GO TO 10
      H=ALFA-P
      IF(H.LT.TAU) H=TAU
   10 R=H/2.D0
      Q=W*R
      V=Q*RO
      T=H*.25D0
      DO 11 D=1,5
      L(D)=F(A+W*(P+T*DFLOAT(D-1)))
   11 CONTINUE
   12 IF(DFLOAT(L1+L2).LT.1.5D0.AND.V.LE..25D0) GO TO 13
      S=DABS(L(1)+L(5)-4.D0*(L(2)+L(4))+6.D0*L(3))
      GO TO 15
   13 I=(A+W*(P+R))*RO+FI
      DO 14 D=1,5
      M(D)=L(D)*DSIN(I)
      Q1(D)=L(D)*DCOS(I)
   14 CONTINUE
      I=M(1)+M(5)-4.D0*(M(2)+M(4))+6.D0*M(3)
      S=Q1(1)+Q1(5)-4.D0*(Q1(2)+Q1(4))+6.D0*Q1(3)
      S=DMAX1(L1*DABS(I),L2*DABS(S))
   15 S=S*R*.42D0
      IF(DABS(S)-Z1) 21,16,16
   16 H=H/2.D0
      IF(64.D0+H-64.D0) 17,17,20
   17 IF(P) 18,18,19
   18 IF(H/4.D0) 19,19,20
   19 XA=(P+A)*W
      P=P+2.D0*H
      H=H*2.D0
      GO TO 21
   20 L(5)=L(3)
      L(3)=L(2)
      R=H*.5D0
      V=W*R*RO
      T=H*.25D0
      U=P+T
      L(2)=F(A+W*U)
      L(4)=F(A+W*(U+R))
      GO TO 12
   21 E1=E1+DABS(S)
      I=(A+W*(P+R))*RO+FI
      Z=DSIN(I)
      BA=DCOS(I)
      Q=W*R
      BD=RO*Q
      BE(4)=DSIN(BD)
      BE(5)=DCOS(BD)
      IF(BD-0.33D0) 22,22,23
   22 BF=BD*0.5D0
      BE(6)=DSIN(BF)
      BE(7)=DCOS(BF)
      G(1)=.2666666666666667D0
      G(2)=.7111111111111111D0*BE(7)
      G(3)=.1555555555555556D0*BE(5)
      G(4)=.7111111111111111D0*BE(6)
      G(5)=.1555555555555556D0*BE(4)
      GO TO 24
   23 BE(1)=1.D0/BD
      BE(2)=BE(1)*BE(1)
      BE(3)=BE(2)*BE(2)
      G(1)=4.D0*BE(2)*(BE(1)*(48.D0*BE(2)-19.D0)*BE(4)+3.D0*
     1(1.D0-16.D0*BE(2))*BE(5))
      G(2)=32.D0*BE(2)*(BE(1)*(5.D0-12.D0*BE(2))*BE(4)-
     1(1.D0-12.D0*BE(2))*BE(5))/3.D0
      G(3)=BE(1)*((3.D0-46.D0*BE(2)+96.D0*BE(3))*BE(4)+2.D0*
     1BE(1)*(7.D0-48.D0*BE(2))*BE(5))/3.D0
      G(4)=-16.D0*BE(2)*((1.D0-3.D0*BE(2))*BE(4)+3.D0*BE(1)*
     1BE(5))/3.D0
      G(5)=BE(1)*(BE(1)*(11.D0-24.D0*BE(2))*BE(4)-3.D0*
     1(1.D0-8.D0*BE(2))*BE(5))/3.D0
   24 X=G(1)*L(3)+G(2)*(L(2)+L(4))+G(3)*(L(1)+L(5))
      Y=G(4)*(L(4)-L(2))+G(5)*(L(5)-L(1))
      RINT1=RINT1+(Z*X+BA*Y)*R
      RINT2=RINT2+(BA*X-Z*Y)*R
      P=P+H
      K=1.D0-P
      N=N+1
      IF(N-1) 26,25,26
   25 H0=H
   26 IF(1.D0+K/64.D0-1.D0) 27,27,29
   27 J=(DABS(F(B))+DABS(L(5)))*K/2.D0
      IF(J-Z2) 33,33,28
   28 E1=E1+J
      GO TO 33
   29 L(1)=L(5)
      IF(S-Z1/32.D0) 30,31,31
   30 H=2.D0*H
   31 IF(H-K) 9,9,32
   32 H=K
      GO TO 9
   33 BB=DMAX1(DABS(RINT1)*DFLOAT(L1),DABS(RINT2)*DFLOAT(L2))
      BB=Z2*(1.D0+BB)
      IF(E1-BB) 40,40,34
   34 IF(IL-1) 35,36,35
   35 BC=DMAX1((DABS(RINT1-RINT3)/(1.D0+DABS(RINT3))*DFLOAT(L1)),
     1(DABS(RINT2-RINT4)/(1.D0+DABS(RINT4))*DFLOAT(L2)))
      IF(BC-Z2) 39,39,36
   36 RINT3=RINT1
      RINT4=RINT2
      IL=2
      EPS=EPS/2.D0**5
      IF(XA+SYS059) 37,37,40
   37 IF(EPS-1.D-15) 39,39,38
   38 H=H0
      GO TO 8
   39 E1=BC
   40 RINT1=RINT1*W
      RINT2=RINT2*W
      E1=E1*W
      IF(.NOT.(NI)) GO TO 41
      RINT1=-RINT1
      RINT2=-RINT2
      C=B
      B=A
      A=C
   41 ALFA=ALFA*W+A
      BETA=BETA*W+A
   42 RETURN
      END
